-- TinyFrapsReminder
-- By Sadiniae <Prophet of Cthulhu> on Garona-Alliance-US
-- local DEBUG = true;

local TinyFrapsReminder = CreateFrame("Frame", "TinyFrapsReminder");
ReadyCheckList = {};
NextCheck = nil;
PvP = nil;
SotA = nil;

-- Binding Variables
BINDING_HEADER_TFR = "TinyFrapsReminder";
BINDING_NAME_STARTSTOP = "Recording Toggle keybind:";

StaticPopupDialogs["TinyFrapsReminder_start"] = {
  text = "Ready Check Completed, Start recording now.",
  button1 = "Okay, Go away.",
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
}

StaticPopupDialogs["TinyFrapsReminder_BG15"] = {
  text = "PvP combat begins in 15 seconds, Start recording now.",
  button1 = "Okay, Go away.",
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
}

StaticPopupDialogs["TinyFrapsReminder_BG30"] = {
  text = "PvP combat begins in 30 seconds, Start recording soon.",
  button1 = "Okay, Go away.",
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
}

StaticPopupDialogs["TinyFrapsReminder_stop"] = {
  text = "Now would be a good time to stop recording.",
  button1 = "Got it.",
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
}

function TFR_StartStop()

	StaticPopup_Hide ("TinyFrapsReminder_start");
	StaticPopup_Hide ("TinyFrapsReminder_BG");
	StaticPopup_Hide ("TinyFrapsReminder_stop");

end

function TFR_CombatCheck(self)
	
	local combat = false;
	local raidmembers = GetNumGroupMembers();
	
	for i = 1, raidmembers do
		local unitname = GetRaidRosterInfo(i);
		if ( unitname ) then
			if ( UnitAffectingCombat(unitname) ) then
				combat = true;
			end
		end
	end
	
	if ( ( PvP ) and ( GetBattlefieldInstanceExpiration() == 0 ) ) then
		combat = true;
	elseif ( SotA ) then
		TinyFrapsReminder:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
		SotA = nil;
	end
	
	if ( combat == false ) then
		StaticPopup_Show ("TinyFrapsReminder_stop");
		NextCheck = nil;
		TinyFrapsReminder:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	end
	
end

function TFR_OnEvent(self, event, ...)
	if ( event == "READY_CHECK_FINISHED" ) then
		StaticPopup_Show ("TinyFrapsReminder_start");
		TinyFrapsReminder:UnregisterEvent("READY_CHECK_FINISHED");
		TinyFrapsReminder:UnregisterEvent("READY_CHECK_CONFIRM");
		TinyFrapsReminder:RegisterEvent("PLAYER_REGEN_DISABLED");
	elseif ( event == "READY_CHECK" ) then
		if	( UnitInRaid("player") ) then
			TinyFrapsReminder:RegisterEvent("READY_CHECK_CONFIRM");
			wipe(ReadyCheckList);
				
			if ( DEBUG ) then ChatFrame1:AddMessage( select(1, ...) .. " started a Ready Check", .9, 0, .9); end
				
			for i = 1, GetNumGroupMembers() do
				local charname, _ = UnitName("raid"..i);
				tinsert(ReadyCheckList, charname);
				if ( charname == select(1, ...) ) then
					tinsert(ReadyCheckList, true);
					
					if ( DEBUG ) then ChatFrame1:AddMessage( charname .. " set to true" , .9, 0, .9); end
					
				else
					tinsert(ReadyCheckList, "NO");
					
					if ( DEBUG ) then ChatFrame1:AddMessage( charname .. " set to NO" , .9, 0, .9); end
					
				end
			end
		end
	elseif ( event == "READY_CHECK_CONFIRM" ) then
		if select(2, ...) then
			readyornot = "Ready."
			local charname, _ = UnitName(select(1, ...));
			local i = 1;
			while ReadyCheckList[i] do
				if ( ReadyCheckList[i] == charname ) then
					ReadyCheckList[i+1] = true;
				end
				i = i + 1;
			end
		else
			readyornot = "Not Ready."
		end
		
		if ( DEBUG ) then ChatFrame1:AddMessage( select(1, ...) .. " is " .. readyornot , .9, 0, .9); end
		
		if ( tContains(ReadyCheckList, "NO") ) then
		
			if ( DEBUG ) then ChatFrame1:AddMessage( "'NO' is there" , .9, 0, .9); end
			
		else
			TinyFrapsReminder:RegisterEvent("READY_CHECK_FINISHED");
		end
	elseif	( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		if (( NextCheck == nil ) or ( NextCheck <= time() )) then
			NextCheck = time() + 2;
			TFR_CombatCheck(self);
		end
	elseif	( event == "PLAYER_REGEN_DISABLED" ) then
		TinyFrapsReminder:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		TinyFrapsReminder:UnregisterEvent("PLAYER_REGEN_DISABLED");
	elseif	( event == "CHAT_MSG_BG_SYSTEM_NEUTRAL" ) then
		if string.match( ... , "15 seconds" ) or string.match( ... , "Fifteen seconds until" ) then
			StaticPopup_Show ("TinyFrapsReminder_BG15");
			PvP = true;
			TinyFrapsReminder:RegisterEvent("PLAYER_REGEN_DISABLED");
		elseif string.match( ... , "30 seconds" ) or string.match( ... , "Thirty seconds until" ) then
			StaticPopup_Show ("TinyFrapsReminder_BG30");
			PvP = true;
			TinyFrapsReminder:RegisterEvent("PLAYER_REGEN_DISABLED");
		end
		if string.match( ... , "Strand of the Ancients begin" ) then
			TinyFrapsReminder:UnregisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL")
			SotA = true;
		end
	end
end

TinyFrapsReminder:RegisterEvent("READY_CHECK");
TinyFrapsReminder:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");

TinyFrapsReminder:SetScript("OnEvent", TFR_OnEvent);
